com.fasterxml.jackson.core

## Class JsonLocation

- java.lang.Object
- - com.fasterxml.jackson.core.JsonLocation

All Implemented Interfaces:
  Serializable

    public class JsonLocation
    extends Object
    implements Serializable

Object that encapsulates Location information used for reporting parsing (or potentially generation) errors, as well as current location within input streams.

See Also:
  Serialized Form

### Field Summary

Fields
`protected int` `_columnNr`
`protected int` `_lineNr`
`protected long` `_totalBytes`
`protected long` `_totalChars`
`static int` `MAX_CONTENT_SNIPPET` Include at most first 500 characters/bytes from contents; should be enough to give context, but not cause unfortunate side effects in things like logs.
`static JsonLocation` `NA` Shared immutable "N/A location" that can be returned to indicate that no location information is available.

### Constructor Summary

Constructors
Constructor and Description
`JsonLocation(Object srcRef, long totalChars, int lineNr, int colNr)`
`JsonLocation(Object sourceRef, long totalBytes, long totalChars, int lineNr, int columnNr)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected StringBuilder` `_appendSourceDesc(StringBuilder sb)`
`boolean` `equals(Object other)`
`long` `getByteOffset()`
`long` `getCharOffset()`
`int` `getColumnNr()`
`int` `getLineNr()`
`Object` `getSourceRef()` Reference to the original resource being read, if one available.
`int` `hashCode()`
`String` `sourceDescription()` Accessor for getting a textual description of source reference (Object returned by `getSourceRef()`), as included in description returned by `toString()`.
`String` `toString()`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### MAX_CONTENT_SNIPPET

    public static final int MAX_CONTENT_SNIPPET

Include at most first 500 characters/bytes from contents; should be enough to give context, but not cause unfortunate side effects in things like logs.

Since:
  2.9
See Also:
  Constant Field Values

#### NA

    public static final JsonLocation NA

Shared immutable "N/A location" that can be returned to indicate that no location information is available.

NOTE: before 2.9, Location was given as String "N/A"; with 2.9 it was removed so that source should be indicated as "UNKNOWN".

#### _totalBytes

    protected final long _totalBytes

#### _totalChars

    protected final long _totalChars

#### _lineNr

    protected final int _lineNr

#### _columnNr

    protected final int _columnNr

### Constructor Detail

#### JsonLocation

    public JsonLocation(Object srcRef,
                        long totalChars,
                        int lineNr,
                        int colNr)

#### JsonLocation

    public JsonLocation(Object sourceRef,
                        long totalBytes,
                        long totalChars,
                        int lineNr,
                        int columnNr)

### Method Detail

#### getSourceRef

    public Object getSourceRef()

Reference to the original resource being read, if one available. For example, when a parser has been constructed by passing a `File` instance, this method would return that File. Will return null if no such reference is available, for example when `InputStream` was used to construct the parser instance.

Returns:
  Source reference this location was constructed with, if any; `null` if none

#### getLineNr

    public int getLineNr()

Returns:
  Line number of the location (1-based)

#### getColumnNr

    public int getColumnNr()

Returns:
  Column number of the location (1-based)

#### getCharOffset

    public long getCharOffset()

Returns:
  Character offset within underlying stream, reader or writer, if available; -1 if not.

#### getByteOffset

    public long getByteOffset()

Returns:
  Byte offset within underlying stream, reader or writer, if available; -1 if not.

#### sourceDescription

    public String sourceDescription()

Accessor for getting a textual description of source reference (Object returned by `getSourceRef()`), as included in description returned by `toString()`.

NOTE: not added as a "getter" to prevent it from getting serialized.

Returns:
  Description of the source reference (see `getSourceRef()`
Since:
  2.9

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### equals

    public boolean equals(Object other)

Overrides:
  `equals` in class `Object`

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

#### _appendSourceDesc

    protected StringBuilder _appendSourceDesc(StringBuilder sb)